# AppSec Patch Release Checklist

This issue is used by the AppSec team to keep track of the [tasks needed to be performed during a patch release]

## Blog Post Preparation Tasks

- [ ] Wait for the blog post draft to be generated and assigned to you for review
- [ ] Notify the following stakeholders about the draft blog MR to inform them of this upcoming release:
     * - [ ] Legal: `@lasayers` and `@emccrann`
     * - [ ] Corporate communications: `@gitlab-com/marketing/corporate_marketing/security-communications`
- [ ] Contact Marketing Ops so they can start planning in advance who is going to help us.
- [ ] Be sure to include any non-security bug fixes under the title `Bug fixes` at the bottom of the blog post.
- [ ] Be sure to include any dependency updates that are mentioned in [the tracking issue](<%= security_tracking_issue.web_url %>) at the bottom of the blog post
- [ ] Confirm that the blog post has the proper version numbers:
  * - [ ] file name
  * - [ ] `title` and `description`
  * - [ ] blog post body
- [ ] Confirm that the blog post filename has the proper format and date (`YYYY-MM-DD-patch-release-gitlab-X-X-X-released.html.md`)
- [ ] Confirm that the `canonical_path` appropriately matches the filename
- [ ] Once the patch release's version numbers are set, replace all placeholders ("14.9.x") in CVE requests
- [ ] :warning: Confirm that the blog post only contains fixes that were included in the release
  + Look for reverted MRs and unlinked issues. Make sure that we are not mentioning fixes that did not make it.
  + Looked for newly linked MRs. Make sure that we are not missing out fixes that did make it into the release.
  + Be sure to do this **before** the blog post is moved over to the canonical `www-gitlab-com` and only check this box then

## Collaborative Tasks

- [ ] `Important:` If the release includes Critical or High severity issues, @ mention `gitlab-com/gl-security/security-assurance/governance-and-field-security/field-security-team/field-security-field-ciso-collaboration` and `kenneth` (from the Support Team) in this issue now.
- [ ] Create an issue in the security communications repository using the [Patch-Release-Email-Alert template](https://gitlab.com/gitlab-com/gl-security/security-communications/communications/-/issues/new?issuable_template=Patch-Release-Email-Alert) and ping the comms team member only if it is not already created.
- [ ] Have at least one other AppSec team member review the draft blog post

## Release Finalization Tasks
- [ ] Wait until the blog post is submitted to canonical (you should receive a ping when you are assigned to it).
- [ ] Notify Comms that we are ready to test the email
- [ ] Make sure the CVE IDs are documented in the corresponding GitLab issues and HackerOne reports
- [ ] Make sure that all the security issues are [linked to the gitlab-org/gitlab issue] that describes the security vulnerability.
- [ ] Close out original GitLab issues in using `scripts/close_release.rb --release-issue IID --close-security-issues`
- [ ] Publish the CVEs using `scripts/close_release.rb --release-issue IID --publish-cves`
- [ ] Post in HackerOne reports that the issues has been resolve using `scripts/close_release.rb --release-issue IID --notify-hackerone`
- [ ] Create an issue in the security communications repository using the [Patch-Release-Email-Alert template](https://gitlab.com/gitlab-com/gl-security/security-communications/communications/-/issues/new?issuable_template=Patch-Release-Email-Alert) with the due date of next release and ping the comms team member on it. Add  the below comment in this issue: `This [link to new comms issue] is the comms issue for [next upcoming patch release] (https://gitlab.com/gitlab-org/gitlab/-/issues/?label_name%5B%5D=upcoming%20security%20release) @[next_appsec_release_manager], please keep the due date of comms issue in sync with the patch release issue and let the marketing team know about the changes in the release date as soon as Delivery team communicates it.`
- [ ] After the blog post is published, run `scripts/make_thankyou.rb` and post it to `#thanks` in Slack
- [ ] Ping `@Sgittlen` to make sure the blog post appears on the blog home page (it does not happen automatically anymore since the CMS migration)
- [ ] Close this issue

## Security Fixes Included in the Release

Complete the checklist below for each issue that is included in the patch release.

<% security_issues.each do |issue| %>

### <%= issue.title %>

- [ ] Issue in Security Repository: <%= issue.web_url %>
- [ ] Issue in Canonical Repository: <%= issue.canonical_issue&.web_url %>
- [ ] CVE
  + [ ] <%= issue.cves_issue&.web_url %>
  + [ ] Versions & description updated
- [ ] Bug bounty council votes are ready (if applicable)
- [ ] Master MR: <%= issue.merge_request_targeting_default_branch&.web_url %>
  + [ ] Approved by AppSec
  + [ ] Merged
- [ ] Included in the blog post
- [ ] Issue [linked to the gitlab-org/gitlab issue] that describes the security vulnerability

<% end %>

## Template

```
### Security Issue Title

- [ ] Issue in Security Repository: https://gitlab.com/gitlab-org/security/gitlab/-/issues/ID+
- [ ] Issue in Canonical Repository: https://gitlab.com/gitlab-org/gitlab/-/issues/ID+
- [ ] CVE
  + [ ] https://gitlab.com/gitlab-org/cves/-/issues/ID+
  + [ ] Versions & description updated
- [ ] Bug bounty council votes are ready (if applicable)
- [ ] Master MR: https://gitlab.com/gitlab-org/security/gitlab/-/merge_requests/ID+
  + [ ] Approved by AppSec
  + [ ] Merged
- [ ] Included in the blog post
``

[tasks needed to be performed during a patch release]: https://gitlab.com/gitlab-org/release/docs/blob/master/general/security/security-engineer.md
[linked to the gitlab-org/gitlab issue]: https://docs.gitlab.com/ee/user/project/issues/related_issues.html#add-a-linked-issue
